#ifndef GLOBALS_H
#define GLOBALS_H
//
// globals.h - This is the file with the header for globals.c
//             for Mr. Ham's ECMA-55 Minimal BASIC compiler.
//
// Copyright (C) 2013,2014  John Gatewood Ham
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// version 2 of the Free Software Foundation License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
#if __STDC_VERSION__ < 199901L
#error "You need a C99 compiler"
#endif
#include <inttypes.h>
#include <stdbool.h>
#include <stdio.h>
#define MAX_STRING_BYTES UINT32_C(18)
#define MAX_FOR_LABEL_BYTES UINT32_C(20)
#define MAX_FOR_VAR_BYTES UINT32_C(20)
#define MAX_SCOPE_BYTES UINT32_C(256)
#define MAX_GOSUB_DEPTH UINT32_C(10)
#define MAX_STRING_OPERANDS UINT32_C(4)
#define MAX_NUMERIC_OPERANDS UINT32_C(40)
#define FORSTACK_DEPTH UINT32_C(100)
#define MAX_SUBSCRIPT_VALUE UINT32_C(10000)
extern const uint32_t MAXLINENO;
extern const uint32_t MAXCOLUMN;
extern const uint32_t EXRAD_NARROW_OUTPUT;
extern const uint32_t EXRAD_WIDE_OUTPUT;
extern const uint32_t SIGNIFICANCE_WIDTH_NARROW_OUTPUT;
extern const uint32_t SIGNIFICANCE_WIDTH_WIDE_OUTPUT;
extern bool use_SSE4_1;
extern bool use_AVX;
extern bool verbose;
extern bool base_is_one;
extern bool need_RND;
extern bool need_SIN;
extern bool need_COS;
extern bool need_TAN;
extern bool need_ATN;
extern bool need_LOG;
extern bool need_EXP;
extern bool need_POW;
extern bool need_SQR;
extern bool need_strcpy;
extern bool need_strcmp;
extern bool need_INPUT;
extern bool need_PRINT;
extern bool need_READ;
extern bool need_BSS_numeric;
extern bool need_BSS_string;
extern bool use_double;
extern bool use_double_output;
extern int32_t optimization_level;
extern const char version[];
void debug_printf(const char *format, ...);
void init_debug_printf(FILE *f);
const char *suffix(const uint32_t n);
#endif
