#ifndef LINENO_H
#define LINENO_H
//
// lineno.h - This is the header file for lineno.c
//            for Mr. Ham's ECMA-55 Minimal BASIC compiler.
//
// Copyright (C) 2013,2014  John Gatewood Ham
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// version 2 of the Free Software Foundation License.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
//
#include <inttypes.h>
#include <stdbool.h>

bool convert_line_number(const char *s,uint32_t *lineno, char *why);
bool add_new_line_number(const uint32_t lineno,char *why,const char *scope);
bool add_new_jump_target(const uint32_t to_lno, const uint32_t from_lno, const char *scope);
bool line_exists(const uint32_t lineno,uint32_t *ndex);
bool jump_target_exists(const uint32_t lineno);
bool verify_all_jump_targets_exist(void);
void dump_line_numbers(void);
void dump_jump_targets(void);
void clear_lineno_data(void);
uint32_t get_next_line(const bool reset);
uint32_t get_next_jump_target(const bool reset);
#endif
